#include "tester_main.h"


TESTER_ProjectTypeDef TESTER = {0};


/**s
  * @brief    Инициализация всех модулей для работы тестера
  */
void TESTER_Init(TESTER_ProjectTypeDef *tester)
{
  TESTER_InterfaceInit(&tester->SwStart, &tester->leds);
  tester->leds.LED1.period = 100;
  
  tester->delay = 250;
  tester->delay_en = 0;
  
  tester->func.disable_reset_call = 0;
  tester->htest = &hTestDiode;
  TESTER_HandleInit(tester->htest, &tester->leds);
  tester->f.flag_init_done = 1;

}


/**s
  * @brief    Функция подготовки тестера к while(1)
  */
void TESTER_pre_while(TESTER_ProjectTypeDef *tester)
{
  tester->leds.LED1.period = LED_BLINK_AS_ON;
}



/**
  * @brief    Главная функция работы тестера
  */
void TESTER_main_while(TESTER_ProjectTypeDef *tester)
{
  if(tester->delay_en)
    msDelay(tester->delay);
  
  /* ТЕСТ В ОБРАТНОМ ВКЛЮЧЕНИИ */
  if(tester->func.test_diode_neg)
  {
    TESTER_TestDiode_NegativePower(tester->htest);
    
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_neg = 0;
  }
    
  /* ТЕСТ В ПРЯМОМ ВКЛЮЧЕНИИ */
  if(tester->func.test_diode_pos)
  {
    TESTER_TestDiode_PositivePower(tester->htest);
    
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_pos = 0;
  }
  /* ТЕСТ ПЕРЕХОДА ИЗ ПРЯМОГО В ОБРАТНОЕ ВКЛЮЧЕНИЯ*/
  if(tester->func.test_diode_posneg)
  {
    TESTER_TestDiode_PosNegPower(tester->htest);
    
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_posneg = 0;
  }
}



/**
  * @brief    Функция работы интерфейса
  */
void TESTER_InterfaceHandle(TESTER_ProjectTypeDef *tester)
{
  if(tester->f.flag_init_done == 0)
    return;
  
  
  
  if(TESTER_ReadSwichStart(&tester->SwStart))
  {
    tester->func.test_diode_posneg = 1;
  }
  
  TESTER_LED_Blink(&tester->leds.LED1);
  
}


/**
  * @brief    Задеркжка главного цикла
  */
void TESTER_main_delay(TESTER_ProjectTypeDef *tester)
{
  if(tester->delay_en)
    msDelay(tester->delay);
}